#####
###  Epoz - a cross-browser-wysiwyg-editor for Zope
##   Copyright (C) 2003 Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#

from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from ImageFile import ImageFile

misc_ = {
 # The Format-Controls
'epoz_script_main.js':ImageFile('skins/epoz/epoz_script_main.js.dtml', globals()),

 # Rendering of the widget
'epoz_script_widget.js':ImageFile('skins/epoz/epoz_script_widget.js.dtml', globals()),

 # Browser-detection
'epoz_script_detect.js':ImageFile('skins/epoz/epoz_script_detect.js.dtml', globals()),

 # Code for the color-selection-popup
'epoz_script_color.html':ImageFile('skins/epoz/epoz_script_color.html.dtml', globals()),

 # Code for the table-popup
'epoz_script_table.html':ImageFile('skins/epoz/epoz_script_table.html.dtml', globals()),

 # The Epoz-Language-Files
 
'epoz_lang_de.js':ImageFile('skins/epoz/epoz_lang_de.js.dtml', globals()),
'epoz_lang_en.js':ImageFile('skins/epoz/epoz_lang_en.js.dtml', globals()),
'epoz_lang_es.js':ImageFile('skins/epoz/epoz_lang_es.js.dtml', globals()),
'epoz_lang_fi.js':ImageFile('skins/epoz/epoz_lang_fi.js.dtml', globals()),
'epoz_lang_fr.js':ImageFile('skins/epoz/epoz_lang_fr.js.dtml', globals()),
'epoz_lang_hu.js':ImageFile('skins/epoz/epoz_lang_hu.js.dtml', globals()),
'epoz_lang_it.js':ImageFile('skins/epoz/epoz_lang_it.js.dtml', globals()),
'epoz_lang_nl.js':ImageFile('skins/epoz/epoz_lang_nl.js.dtml', globals()),
'epoz_lang_no.js':ImageFile('skins/epoz/epoz_lang_no.js.dtml', globals()),
'epoz_lang_pl.js':ImageFile('skins/epoz/epoz_lang_pl.js.dtml', globals()),
'epoz_lang_pt-br.js':ImageFile('skins/epoz/epoz_lang_pt-br.js.dtml', globals()),
'epoz_lang_ru.js':ImageFile('skins/epoz/epoz_lang_ru.js.dtml', globals()),

 # The Epoz-Buttons
 
'epoz_button_bgcolor.gif':ImageFile('skins/epoz/epoz_button_bgcolor.gif', globals()),
'epoz_button_bold.gif':ImageFile('skins/epoz/epoz_button_bold.gif', globals()),
'epoz_button_centre.gif':ImageFile('skins/epoz/epoz_button_centre.gif', globals()),
'epoz_button_hr.gif':ImageFile('skins/epoz/epoz_button_hr.gif', globals()),
'epoz_button_hyperlink.gif':ImageFile('skins/epoz/epoz_button_hyperlink.gif', globals()),
'epoz_button_image.gif':ImageFile('skins/epoz/epoz_button_image.gif', globals()),
'epoz_button_indent.gif':ImageFile('skins/epoz/epoz_button_indent.gif', globals()),
'epoz_button_italic.gif':ImageFile('skins/epoz/epoz_button_italic.gif', globals()),
'epoz_button_left_just.gif':ImageFile('skins/epoz/epoz_button_left_just.gif', globals()),
'epoz_button_list.gif':ImageFile('skins/epoz/epoz_button_list.gif', globals()),
'epoz_button_numbered_list.gif':ImageFile('skins/epoz/epoz_button_numbered_list.gif', globals()),
'epoz_button_outdent.gif':ImageFile('skins/epoz/epoz_button_outdent.gif', globals()),
'epoz_button_redo.gif':ImageFile('skins/epoz/epoz_button_redo.gif', globals()),
'epoz_button_right_just.gif':ImageFile('skins/epoz/epoz_button_right_just.gif', globals()),
'epoz_button_strikethrough.gif':ImageFile('skins/epoz/epoz_button_strikethrough.gif', globals()),
'epoz_button_subscript.gif':ImageFile('skins/epoz/epoz_button_subscript.gif', globals()),
'epoz_button_superscript.gif':ImageFile('skins/epoz/epoz_button_superscript.gif', globals()),
'epoz_button_table.gif':ImageFile('skins/epoz/epoz_button_table.gif', globals()),
'epoz_button_textcolor.gif':ImageFile('skins/epoz/epoz_button_textcolor.gif', globals()),
'epoz_button_tools.gif':ImageFile('skins/epoz/epoz_button_tools.gif', globals()),
'epoz_button_underline.gif':ImageFile('skins/epoz/epoz_button_underline.gif', globals()),
'epoz_button_undo.gif':ImageFile('skins/epoz/epoz_button_undo.gif', globals()),
}


def Epoz(self, name, data='', toolbox='', lang='en', 
               path='', widget='',
               style='width: 600px; height: 250px; border: 1px solid #000000;', 
               button='background-color: #EFEFEF; border: 1px solid #A0A0A0; cursor: pointer; margin-right: 1px; margin-bottom: 1px;',
               css='', charset='iso-8859-1'):
    """ Create an Epoz-Wysiwyg-Editor.
    
        name : the name of the form-element which submits the data
        data : the data to edit
        toolbox : a link to a HTML-Page which delivers additional tools
        lang: a code for the language-file (en,de,...)
        path : path to Epoz-Javascript. Needed mainly for Plone (portal_url).
        widget: You can specify a path to an alternative JavaScript for
                epoz_script_widget.js
        style : style-definition for the editor-area
        button : style-definiton for buttons
        css : url to a css which should be used for rendering 
               content in editor-area
        charset : charset which is edited in the editor-area
        
        If Epoz can't create a Rich-Text-Editor, a simple textarea is created.
    """
    
    if data is None:
        data=''
    
    js_data = data

    # Quote newlines and single quotes, so the Epoz-JavaScript won't break.
    # Needs to be a list and no dictionary, cause we need order!!!
    
    quotes = (("\\","\\\\"), ("\n","\\n"), ("\r","\\r"), ("'","\\'"))
    
    for item in quotes:
        js_data = js_data.replace(item[0], item[1])

    # Determine the correct path for VirtualHostMonsters & PCGI & etc.pp.
    if not path:
        path = "%s/misc_/Epoz/" % (self.REQUEST.get('BASEPATH1',''),)

    i18n='<script language="JavaScript" type="text/javascript" src="%sepoz_lang_en.js"></script>' % (path,)
    if lang<>'en':
        i18n += '<script language="JavaScript" type="text/javascript" src="%sepoz_lang_%s.js"></script>' % (path, lang)
        
    if not widget:
       widget = "%sepoz_script_widget.js" % path

    # Return the HTML-Code for the Epoz-Rich-Text-Editor
            
    return """
<iframe id="EpozIFrame" style="position: absolute; visibility: hidden; width: 0px; height: 0px;"></iframe>
%(i18n)s
<script language="JavaScript" type="text/javascript" src="%(widget)s"></script>
<script language="JavaScript" type="text/javascript" src="%(path)sepoz_script_detect.js"></script>
<script language="JavaScript" type="text/javascript" src="%(path)sepoz_script_main.js"></script>
<script language="JavaScript" type="text/javascript">
<!--
InitEpoz('%(name)s','%(js_data)s','%(path)s','%(toolbox)s','%(style)s','%(button)s','%(css)s','%(charset)s');
//-->
</script>
<noscript><textarea name="%(name)s" style="%(style)s">%(data)s</textarea></noscript>
""" % {
       'i18n': i18n,
       'widget':  widget,
       'path':    path,
       'name':    name,
       'js_data': js_data,
       'toolbox': toolbox,
       'style':   style,
       'button':  button,
       'css': css,
       'charset': charset,
       'data':    data
      }
 
# Register Epoz as global method
# Register epoz_blank_iframe.html as global PageTemplate

methods = {
'Epoz': Epoz,
'epoz_blank_iframe.html': PageTemplateFile('skins/epoz/epoz_blank_iframe.html.pt', globals()) ,
}


# And now try to register Epoz for CMF/Plone

try:
    from Products.CMFCore.DirectoryView import registerDirectory
    
    global cmfepoz_globals
    cmfepoz_globals=globals()

    def initialize(context):
        registerDirectory('skins', cmfepoz_globals)
except:
    pass
